Remove unused roles permissions column
Status: Closed
Priority: Normal
Assignee: Dominic Cleal
Category: Database
Target version: 1.12.0
Difficulty: Fixed in Releases:
Triaged: Found in Releases:
Bugzilla link: Red Hat JIRA:
Pull request: https://github.com/theforeman/foreman/p
ull/3289
Description

The roles table has a permissions text column that pre-#812 was a serialised list of permissions assigned to the role. #812 changed
this so that permissions are associated via filters, and permissions is now an has_many association through filters, but the column
wasn't removed in that patch.

The presence of the column was causing a test failure on Rails 4.2 because it has the same name as the association.

—-—— expected

+++ actual

@@ -1 +1 Q@

—#<ActiveRecord::Associations::CollectionProxy []>

+#<ActiveRecord: :Associations::CollectionProxy [#<Permission id: 769440046, name: "view_ptables",

resource_type: "Ptable", created_at: "2013-12-04 08:41:05", updated_at: "2013-12-04 08:41:05">]>
(Minitest::Assertion)

/var/lib/workspace/workspace/test_develop_pr_core/database/mysqgl/label/fast/ruby/2.2/test/function

al/roles_controller_test.rb:82

Under MySQL, the column has a limit of 64k characters, which validates_lengths_from_database enforces. In the, it created a Role
then called #add_permissions! on it, but calling .permissions after would return an empty array on MySQL (not other DBs).

The length validation on the permissions field was called when the role was first created, and this caused the permissions
association to be cached by Rails. Reloading the association worked, but also removing the identically named and unused attribute
also prevents the validation messing with the association.

Related issues:
Blocks Foreman - Feature #13244: Upgrade Ruby on Rails to 4.2 Closed 01/15/2016

Associated revisions

Revision 1657a147 - 03/08/2016 10:44 AM - Dominic Cleal

fixes #14093 - remove unused permissions column from roles

History

#1 - 03/08/2016 07:28 AM - Dominic Cleal
- Blocks Feature #13244: Upgrade Ruby on Rails to 4.2 added

#2 - 03/08/2016 07:29 AM - The Foreman Bot
- Status changed from Assigned to Ready For Testing
- Pull request https://github.com/theforeman/foreman/pull/3289 added

#3 - 03/08/2016 11:01 AM - Dominic Cleal
- Status changed from Ready For Testing to Closed
- % Done changed from 0 to 100
https://projects.theforeman.org/issues/812

Applied in changeset 1657a147e61f74be373a86efea63bd9584ece748.

#4 - 03/09/2016 09:53 AM - Dominic Cleal

- translation missing: en.field_release set to 136
